Package net.sf.saxon.value

## Class BigDecimalValue

- java.lang.Object
- - net.sf.saxon.value.AtomicValue
  - - net.sf.saxon.value.NumericValue
    - - net.sf.saxon.value.DecimalValue
      - - net.sf.saxon.value.BigDecimalValue

- All Implemented Interfaces:
    `java.lang.Comparable<NumericValue>`, `java.lang.Iterable<AtomicValue>`, `AtomicMatchKey`, `AtomicSequence`, `GroundedValue`, `IdentityComparable`, `Item`, `Sequence`, `ConversionResult`

      public final class BigDecimalValue
      extends DecimalValue

  An implementation class for decimal values other than integers
  Since:
    9.8. This class was previously named "DecimalValue". In 9.8 a new DecimalValue class is introduced, to more faithfully reflect the XDM type hierarchy, so that every instance of xs:decimal is now implemented as an instance of DecimalValue.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `protected static class` | `BigDecimalValue.DecimalComparable` | A Comparable that performs comparison of a DecimalValue either with another DecimalValue or with some other representation of an XPath numeric value

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.math.BigDecimal` | `BIG_DECIMAL_ONE_BILLION` |
    `static java.math.BigDecimal` | `BIG_DECIMAL_ONE_MILLION` |
    `static int` | `DIVIDE_PRECISION` |
    `static java.math.BigDecimal` | `MAX_INT` |
    `static BigDecimalValue` | `ONE` |
    `static BigDecimalValue` | `THREE` |
    `static BigDecimalValue` | `TWO` |
    `static BigDecimalValue` | `ZERO` |

    - ### Fields inherited from class net.sf.saxon.value.AtomicValue

      `typeLabel`

    - ### Fields inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `NaN_MATCH_KEY`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BigDecimalValue​(double in)` | Constructor supplying a double
    `BigDecimalValue​(long in)` | Constructor supplying a long integer
    `BigDecimalValue​(java.math.BigDecimal value)` | Constructor supplying a BigDecimal

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `NumericValue` | `abs()` | Get the absolute value as defined by the XPath abs() function
    `int` | `asSubscript()` | Test whether a number is a possible subscript into a sequence, that is, a whole number greater than zero and less than 2^31
    `static boolean` | `castableAsDecimal​(java.lang.CharSequence in)` | Test whether a string is castable to a decimal value
    `NumericValue` | `ceiling()` | Implement the XPath ceiling() function
    `int` | `compareTo​(long other)` | Compare the value to a long
    `int` | `compareTo​(NumericValue other)` | Compare the value to another numeric value
    `AtomicValue` | `copyAsSubType​(AtomicType typeLabel)` | Create a copy of this atomic value, with a different type label
    `static FastStringBuffer` | `decimalToString​(java.math.BigDecimal value, FastStringBuffer fsb)` | Convert a decimal value to a string, using the XPath rules for formatting
    `boolean` | `effectiveBooleanValue()` | Get the effective boolean value of the value.
    `NumericValue` | `floor()` | Implement the XPath floor() function
    `java.lang.CharSequence` | `getCanonicalLexicalRepresentation()` | Get the canonical lexical representation as defined in XML Schema.
    `java.math.BigDecimal` | `getDecimalValue()` | Get the value
    `double` | `getDoubleValue()` | Get the numeric value as a double
    `float` | `getFloatValue()` | Get the numeric value converted to a float
    `java.lang.CharSequence` | `getPrimitiveStringValue()` | Get the value as a String
    `BuiltInAtomicType` | `getPrimitiveType()` | Determine the primitive type of the value.
    `java.lang.Comparable` | `getSchemaComparable()` | Get an object that implements XML Schema comparison semantics
    `int` | `hashCode()` | Get the hashCode.
    `boolean` | `isIdentical​(AtomicValue v)` | Determine whether two atomic values are identical, as determined by XML Schema rules.
    `boolean` | `isWholeNumber()` | Determine whether the value is a whole number, that is, whether it compares equal to some integer
    `long` | `longValue()` | Return the numeric value as a Java long.
    `static ConversionResult` | `makeDecimalValue​(java.lang.CharSequence in, boolean validate)` | Factory method to construct a DecimalValue from a string
    `NumericValue` | `negate()` | Negate the value
    `static BigDecimalValue` | `parse​(java.lang.CharSequence in)` | Factory method to construct a DecimalValue from a string, throwing an unchecked exception if the value is invalid
    `NumericValue` | `round​(int scale)` | Implement the XPath round() function
    `NumericValue` | `roundHalfToEven​(int scale)` | Implement the XPath round-half-to-even() function
    `int` | `signum()` | Determine whether the value is negative, zero, or positive

    - ### Methods inherited from class net.sf.saxon.value.NumericValue

      `equals, getXPathComparable, isInteger, isNegativeZero, parseNumber, toString`

    - ### Methods inherited from class net.sf.saxon.value.AtomicValue

      `asAtomic, asMapKey, atomize, checkPermittedContents, checkValidInJavascript, getCardinality, getComponent, getGenre, getItemType, getLength, getStringValue, getStringValueCS, getUType, head, identityHashCode, isIdentical, isNaN, itemAt, iterate, iterator, setTypeLabel`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `asAtomic`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `isStreamed, reduce, subsequence, toShortString`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Field Detail

    - #### DIVIDE_PRECISION

          public static final int DIVIDE_PRECISION

      See Also:
        Constant Field Values

    - #### BIG_DECIMAL_ONE_MILLION

          public static final java.math.BigDecimal BIG_DECIMAL_ONE_MILLION

    - #### BIG_DECIMAL_ONE_BILLION

          public static final java.math.BigDecimal BIG_DECIMAL_ONE_BILLION

    - #### ZERO

          public static final BigDecimalValue ZERO

    - #### ONE

          public static final BigDecimalValue ONE

    - #### TWO

          public static final BigDecimalValue TWO

    - #### THREE

          public static final BigDecimalValue THREE

    - #### MAX_INT

          public static final java.math.BigDecimal MAX_INT

  - ### Constructor Detail

    - #### BigDecimalValue

          public BigDecimalValue​(java.math.BigDecimal value)

      Constructor supplying a BigDecimal
      Parameters:
        `value` - the value of the DecimalValue

    - #### BigDecimalValue

          public BigDecimalValue​(double in)
                          throws ValidationException

      Constructor supplying a double
      Parameters:
        `in` - the value of the DecimalValue
      Throws:
        `ValidationException` - if the supplied value cannot be converted, typically because it is INF or NaN.

    - #### BigDecimalValue

          public BigDecimalValue​(long in)

      Constructor supplying a long integer
      Parameters:
        `in` - the value of the DecimalValue

  - ### Method Detail

    - #### makeDecimalValue

          public static ConversionResult makeDecimalValue​(java.lang.CharSequence in,
                                                          boolean validate)

      Factory method to construct a DecimalValue from a string
      Parameters:
        `in` - the value of the DecimalValue
        `validate` - true if validation is required; false if the caller knows that the value is valid
      Returns:
        the required DecimalValue if the input is valid, or a ValidationFailure encapsulating the error message if not.

    - #### parse

          public static BigDecimalValue parse​(java.lang.CharSequence in)
                                       throws java.lang.NumberFormatException

      Factory method to construct a DecimalValue from a string, throwing an unchecked exception if the value is invalid
      Parameters:
        `in` - the lexical representation of the DecimalValue
      Returns:
        the required DecimalValue
      Throws:
        `java.lang.NumberFormatException` - if the value is invalid

    - #### castableAsDecimal

          public static boolean castableAsDecimal​(java.lang.CharSequence in)

      Test whether a string is castable to a decimal value
      Parameters:
        `in` - the string to be tested
      Returns:
        true if the string has the correct format for a decimal

    - #### copyAsSubType

          public AtomicValue copyAsSubType​(AtomicType typeLabel)

      Create a copy of this atomic value, with a different type label
      Specified by:
        `copyAsSubType` in class `AtomicValue`
      Parameters:
        `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.
      Returns:
        the copied value

    - #### getPrimitiveType

          public BuiltInAtomicType getPrimitiveType()

      Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.
      Specified by:
        `getPrimitiveType` in class `AtomicValue`
      Returns:
        the primitive type

    - #### getDoubleValue

          public double getDoubleValue()

      Get the numeric value as a double
      Specified by:
        `getDoubleValue` in class `NumericValue`
      Returns:
        A double representing this numeric value; NaN if it cannot be converted

    - #### getFloatValue

          public float getFloatValue()

      Get the numeric value converted to a float
      Specified by:
        `getFloatValue` in class `NumericValue`
      Returns:
        a float representing this numeric value; NaN if it cannot be converted

    - #### longValue

          public long longValue()
                         throws XPathException

      Return the numeric value as a Java long.
      Specified by:
        `longValue` in class `NumericValue`
      Returns:
        the numeric value as a Java long. This performs truncation towards zero.
      Throws:
        `XPathException` - if the value cannot be converted

    - #### getDecimalValue

          public java.math.BigDecimal getDecimalValue()

      Get the value
      Specified by:
        `getDecimalValue` in class `NumericValue`
      Returns:
        a decimal representing this numeric value;

    - #### hashCode

          public int hashCode()

      Get the hashCode. This must conform to the rules for other NumericValue hashcodes
      Specified by:
        `hashCode` in class `NumericValue`
      Returns:
        the hash code of the numeric value
      See Also:
        `NumericValue.hashCode()`

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue()

      Description copied from class: `NumericValue`
      Get the effective boolean value of the value. This override of this method throws no exceptions.
      Specified by:
        `effectiveBooleanValue` in interface `GroundedValue`
      Specified by:
        `effectiveBooleanValue` in class `NumericValue`
      Returns:
        true, unless the value is boolean false, numeric zero, or zero-length string

    - #### getCanonicalLexicalRepresentation

          public java.lang.CharSequence getCanonicalLexicalRepresentation()

      Get the canonical lexical representation as defined in XML Schema. This is not always the same as the result of casting to a string according to the XPath rules. For xs:decimal, the canonical representation always contains a decimal point.
      Specified by:
        `getCanonicalLexicalRepresentation` in interface `AtomicSequence`
      Overrides:
        `getCanonicalLexicalRepresentation` in class `AtomicValue`
      Returns:
        the canonical lexical representation if defined in XML Schema; otherwise, the result of casting to string according to the XPath 2.0 rules

    - #### getPrimitiveStringValue

          public java.lang.CharSequence getPrimitiveStringValue()

      Get the value as a String
      Specified by:
        `getPrimitiveStringValue` in class `AtomicValue`
      Returns:
        a String representation of the value

    - #### decimalToString

          public static FastStringBuffer decimalToString​(java.math.BigDecimal value,
                                                         FastStringBuffer fsb)

      Convert a decimal value to a string, using the XPath rules for formatting
      Parameters:
        `value` - the decimal value to be converted
        `fsb` - the FastStringBuffer to which the value is to be appended
      Returns:
        the supplied FastStringBuffer, suitably populated

    - #### negate

          public NumericValue negate()

      Negate the value
      Specified by:
        `negate` in class `NumericValue`
      Returns:
        a value, of the same type as the original, with its sign inverted

    - #### floor

          public NumericValue floor()

      Implement the XPath floor() function
      Specified by:
        `floor` in class `NumericValue`
      Returns:
        a value, of the same type as that supplied, rounded towards minus infinity

    - #### ceiling

          public NumericValue ceiling()

      Implement the XPath ceiling() function
      Specified by:
        `ceiling` in class `NumericValue`
      Returns:
        a value, of the same type as that supplied, rounded towards plus infinity

    - #### round

          public NumericValue round​(int scale)

      Implement the XPath round() function
      Specified by:
        `round` in class `NumericValue`
      Parameters:
        `scale` - the number of decimal places required in the result (supply 0 for rounding to an integer)
      Returns:
        a value, of the same type as that supplied, rounded towards the nearest whole number (0.5 rounded up)

    - #### roundHalfToEven

          public NumericValue roundHalfToEven​(int scale)

      Implement the XPath round-half-to-even() function
      Specified by:
        `roundHalfToEven` in class `NumericValue`
      Parameters:
        `scale` - the decimal position for rounding: e.g. 2 rounds to a multiple of 0.01, while -2 rounds to a multiple of 100
      Returns:
        a value, of the same type as the original, rounded towards the nearest multiple of 10**(-scale), with rounding towards the nearest even number if two values are equally near

    - #### signum

          public int signum()

      Determine whether the value is negative, zero, or positive
      Specified by:
        `signum` in class `NumericValue`
      Returns:
        -1 if negative, 0 if zero, +1 if positive, NaN if NaN

    - #### isWholeNumber

          public boolean isWholeNumber()

      Determine whether the value is a whole number, that is, whether it compares equal to some integer
      Specified by:
        `isWholeNumber` in class `NumericValue`
      Returns:
        true if the value is a whole number

    - #### asSubscript

          public int asSubscript()

      Test whether a number is a possible subscript into a sequence, that is, a whole number greater than zero and less than 2^31
      Specified by:
        `asSubscript` in class `NumericValue`
      Returns:
        the number as an int if it is a possible subscript, or -1 otherwise

    - #### abs

          public NumericValue abs()

      Get the absolute value as defined by the XPath abs() function
      Specified by:
        `abs` in class `NumericValue`
      Returns:
        the absolute value
      Since:
        9.2

    - #### compareTo

          public int compareTo​(NumericValue other)

      Compare the value to another numeric value
      Specified by:
        `compareTo` in interface `java.lang.Comparable<NumericValue>`
      Overrides:
        `compareTo` in class `NumericValue`
      Parameters:
        `other` - The other numeric value
      Returns:
        -1 if this one is the lower, 0 if they are numerically equal, +1 if this one is the higher, or if either value is NaN. Where NaN values are involved, they should be handled by the caller before invoking this method.

    - #### compareTo

          public int compareTo​(long other)

      Compare the value to a long
      Specified by:
        `compareTo` in class `NumericValue`
      Parameters:
        `other` - the value to be compared with
      Returns:
        -1 if this is less, 0 if this is equal, +1 if this is greater or if this is NaN

    - #### getSchemaComparable

          public java.lang.Comparable getSchemaComparable()

      Get an object that implements XML Schema comparison semantics
      Specified by:
        `getSchemaComparable` in interface `AtomicSequence`
      Specified by:
        `getSchemaComparable` in class `AtomicValue`
      Returns:
        a Comparable that follows XML Schema comparison rules

    - #### isIdentical

          public boolean isIdentical​(AtomicValue v)

      Determine whether two atomic values are identical, as determined by XML Schema rules. This is a stronger test than equality (even schema-equality); for example two dateTime values are not identical unless they are in the same timezone.

      Note that even this check ignores the type annotation of the value. The integer 3 and the short 3 are considered identical, even though they are not fully interchangeable. "Identical" means the same point in the value space, regardless of type annotation.

      NaN is identical to itself.

      Overrides:
        `isIdentical` in class `AtomicValue`
      Parameters:
        `v` - the other value to be compared with this one
      Returns:
        true if the two values are identical, false otherwise.